package pl.net.linux.krzak.kchat.applet;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.awt.Frame;
import java.awt.Button;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Color;
import java.awt.List;
import java.awt.Dimension;
import java.awt.Label;
import java.awt.Scrollbar;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.lang.String;
import java.util.Vector;
import pl.net.linux.krzak.kchat.util.kChatTextArea;
import pl.net.linux.krzak.kchat.util.kButton;
import pl.net.linux.krzak.kchat.util.kScrollbar;

public class kChatApplet extends Applet implements KeyListener, MouseListener, Runnable {
  Thread appletThread;
  public kChatNet net = null;
  public String login = "any";
  public String chan  = "free";
  public kChatTextArea chanWnd = null;
  public kChatModerator moder = null;
  public kScrollbar sbar = new kScrollbar(kScrollbar.VERTICAL,0,0,0,0);
//  public Scrollbar sbar = new Scrollbar(Scrollbar.VERTICAL,0,0,0,0);
  public TextField input = null;
  public String msgColor = "#cccccc";
  public List nList = null;
  public boolean moderate = false;
  public String moderatorNick = "";
  public String selectedNick = "";
  public Vector windowsList = new Vector();
  public String TXT[] = new String[19];
  public Label topicLabel = new Label("",Label.CENTER);
  public java.net.URL logouthtml = null;
  public kChatActions actions = null;
  public kButton bLogout = new kButton();
  public kButton bPrivate = new kButton();
  public kButton bModerator = new kButton();
  public kButton bClose = new kButton();
  public AppletContext context = null;
  public Color foreground = Color.black;
  public Color background = Color.white;
  public String alertColor = "#cc11cc";
  private int clickCount = 0;



public void init() {
 setLayout(new BorderLayout());
 context  = getAppletContext();
 setBackground(background);

 chanWnd = new kChatTextArea(300,5);
 chanWnd.setFont(new Font("fixed", Font.BOLD, 12));
 chanWnd.setBackground(background);
 chanWnd.addScroll(sbar);

 actions = new kChatActions(this);

 nList = new List();
 nList.addItemListener(actions);
 nList.addMouseListener(this);
 nList.setBackground(background);
 nList.setForeground(foreground);

 bLogout.setActionCommand("LOGOUT");
 bLogout.addActionListener(actions);
 bLogout.setForeground(foreground);
 bLogout.setBackground(background);
 bPrivate.setActionCommand("PRIVATE");
 bPrivate.addActionListener(actions);
 bPrivate.setForeground(foreground);
 bPrivate.setBackground(background);
 bModerator.setActionCommand("MODERATOR");
 bModerator.addActionListener(actions);
 bModerator.setForeground(foreground);
 bModerator.setBackground(background);

 input = new TextField("");
 input.setFont(new Font("fixed", Font.BOLD, 12));
 input.setBackground(background);
 input.setForeground(foreground);
 input.addKeyListener(this);

 Panel panel = new Panel(new BorderLayout());
 Panel leftP = new Panel(new BorderLayout());
 Panel downP = new Panel(new BorderLayout());
 Panel rightP = new Panel(new BorderLayout());
 Panel kButtonsP = new Panel(new BorderLayout());
 Panel chanwndP = new Panel(new BorderLayout());

 kButtonsP.add(bPrivate, BorderLayout.NORTH);
 if (getParameter("moderbutton").equals("yes")) kButtonsP.add(bModerator, BorderLayout.CENTER);
 kButtonsP.add(bLogout,BorderLayout.SOUTH);

 rightP.add(nList, BorderLayout.CENTER);
 rightP.add(kButtonsP, BorderLayout.SOUTH);

 chanwndP.add(chanWnd, BorderLayout.CENTER);
 chanwndP.add(sbar, BorderLayout.EAST);
 
 leftP.add(chanwndP, BorderLayout.CENTER);
 leftP.add(rightP, BorderLayout.EAST);

 downP.add(input, BorderLayout.CENTER);

 panel.add(topicLabel, BorderLayout.NORTH);
 panel.add(leftP, BorderLayout.CENTER);
 panel.add(downP, BorderLayout.SOUTH);

 add(panel,BorderLayout.CENTER);
 invalidate();
 doLayout();

 msgColor = getParameter("color");

 logouthtml = getDocumentBase();

 // Net Thread
 try {
 net = new kChatNet(getCodeBase().getHost(),getParameter("port"),this);
 } catch (java.io.IOException e) {
    chanWnd.appendText(TXT[18],alertColor);
    e.printStackTrace();
 }

 chan = getParameter("chan");
 // get texts
 net.send("*LANG");
 // login to system
 net.send("*LOGIN|SYSTEM|"+getParameter("login")+"|"+ getParameter("pass") +"|"+getParameter("chan")+"|"+getParameter("color")+"|");
 // get users list
 net.send("*CHECK|"+getParameter("chan")+"|");
 // get topic of channel
 net.send("*TOPIC|GET|"+getParameter("chan")+"|");
}

public String compileText(String text,String param) {
    int paramTmp = text.indexOf("%");
    String t = text.substring(0,paramTmp) + param + text.substring(paramTmp+1);
    return(t);
    }


public void keyTyped(KeyEvent e) { }
public void keyPressed(KeyEvent e) {
	if ((e.getKeyCode() == KeyEvent.VK_ENTER)
 && (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.getText().trim();
		if (net != null)
		    net.send("*MSG|" + login + "|CHAN|" + input.getText().replace('|',':') + "|" + msgColor + "|");
		input.setText("");
		input.setCaretPosition(0);
		}
}

public void keyReleased(KeyEvent e)
{
	if ((e.getKeyCode() == KeyEvent.VK_ENTER)
 && (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.setText("");
		input.setCaretPosition(0);
		}
}


public synchronized void closeAllFloatingWindow() {
 for (int i=0; i < windowsList.size(); i++){
     MsgFloatingWindow tmpMFW = (MsgFloatingWindow)windowsList.elementAt(i);
     tmpMFW.fr.dispose();
     }
 windowsList.removeAllElements();
}


public boolean alreadyExistNick(String nick) {
 for (int i=0; i < windowsList.size(); i++){
     MsgFloatingWindow tmpMFW = (MsgFloatingWindow)windowsList.elementAt(i);
     if (tmpMFW.nick.equals(nick)) return(true);
     }
 return(false);
}


public synchronized MsgFloatingWindow getMsgWindowFromList(String nick) {
 for (int i=0; i < windowsList.size(); i++){
     MsgFloatingWindow tmpMFW = (MsgFloatingWindow)windowsList.elementAt(i);
     if (tmpMFW.nick.equals(nick)) return(tmpMFW);
     }
 return(null);
}



public synchronized void destroy() {
    if (net != null) {
	net.send("*CLOSE");
	net.disconnect();
	context.showDocument(logouthtml,"_self");
	}
}

public void update(Graphics g) { super.paint(g); }
public void start(Graphics g) { repaint(); }
public void run() {
    appletThread = new Thread(this);
    appletThread.start();
    }
    
public void stop(Graphics g) {
    closeAllFloatingWindow();
    if (net != null) {
	net.disconnect();
	net=null;
	}
    appletThread = null;
    }
    
public void paint(Graphics g) { super.paint(g); }


    public void mouseEntered(MouseEvent event) {
    }
    public void mouseExited(MouseEvent event) {
    clickCount = 0;
    }
    public void mousePressed(MouseEvent event) {
    }
    public void mouseReleased(MouseEvent event) {
    if (clickCount > 2) clickCount=0;
    }
    public void mouseClicked(MouseEvent event) {
 
    clickCount++;
    if (clickCount == 2)   { 
    	if ((!(login.equals(selectedNick))) &&
	    (!(selectedNick.equals(""))) &&
	    (alreadyExistNick(selectedNick) == false)) {
	    MsgFloatingWindow fw = new MsgFloatingWindow(compileText(TXT[12],selectedNick),selectedNick,this);
	    fw.setVisible(true);
//    	    try {
//	    play(new java.net.URL(soundFile));
//	    } catch (java.net.MalformedURLException ee) {}
	   }
	}
    
    }



}
